<?php 
class ControllerPaymentWorldNetHPP extends Controller {
	private $error = array(); 

	public function index() {
		$this->load->language('payment/worldnethpp');

		$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->load->model('setting/setting');
			
			$this->model_setting_setting->editSetting('worldnethpp', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token']);
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_worldnet'] = $this->language->get('text_worldnet');
		$this->data['text_cashflows'] = $this->language->get('text_cashflows');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		$this->data['text_on'] = $this->language->get('text_on');
		$this->data['text_off'] = $this->language->get('text_off');
		$this->data['text_true'] = $this->language->get('text_true');
		$this->data['text_false'] = $this->language->get('text_false');

		$this->data['currency_eur'] = $this->language->get('currency_eur');
		$this->data['currency_gbp'] = $this->language->get('currency_gbp');
		$this->data['currency_usd'] = $this->language->get('currency_usd');
		
		$this->data['entry_gateway'] = $this->language->get('entry_gateway');

		$this->data['entry_currency1'] = $this->language->get('entry_currency1');
		$this->data['entry_terminal1'] = $this->language->get('entry_terminal1');
		$this->data['entry_secret1'] = $this->language->get('entry_secret1');
		$this->data['entry_currency2'] = $this->language->get('entry_currency2');
		$this->data['entry_terminal2'] = $this->language->get('entry_terminal2');
		$this->data['entry_secret2'] = $this->language->get('entry_secret2');
		$this->data['entry_currency3'] = $this->language->get('entry_currency3');
		$this->data['entry_terminal3'] = $this->language->get('entry_terminal3');
		$this->data['entry_secret3'] = $this->language->get('entry_secret3');

		$this->data['entry_test'] = $this->language->get('entry_test');
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');		
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_send_receipt'] = $this->language->get('entry_send_receipt');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

 		if (isset($this->error['gateway'])) {
			$this->data['error_gateway'] = $this->error['gateway'];
		} else {
			$this->data['error_gateway'] = '';
		}

  		if (isset($this->error['terminal1'])) {
			$this->data['error_terminal1'] = $this->error['terminal1'];
		} else {
			$this->data['error_terminal1'] = '';
		}

 		if (isset($this->error['secret1'])) {
			$this->data['error_secret1'] = $this->error['secret1'];
		} else {
			$this->data['error_secret1'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_payment'),
      		'separator' => ' :: '
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=payment/worldnethpp&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
				
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=payment/worldnethpp&token=' . $this->session->data['token'];
		
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'];
		
		if (isset($this->request->post['worldnethpp_gateway'])) {
			$this->data['worldnethpp_gateway'] = $this->request->post['worldnethpp_gateway'];
		} else {
			$this->data['worldnethpp_gateway'] = $this->config->get('worldnethpp_gateway');
		}
		
		if (isset($this->request->post['worldnethpp_currency1'])) {
			$this->data['worldnethpp_currency1'] = $this->request->post['worldnethpp_currency1'];
		} else {
			$this->data['worldnethpp_currency1'] = $this->config->get('worldnethpp_currency1');
		}
		
		if (isset($this->request->post['worldnethpp_terminal1'])) {
			$this->data['worldnethpp_terminal1'] = $this->request->post['worldnethpp_terminal1'];
		} else {
			$this->data['worldnethpp_terminal1'] = $this->config->get('worldnethpp_terminal1');
		}
		
		if (isset($this->request->post['worldnethpp_secret1'])) {
			$this->data['worldnethpp_secret1'] = $this->request->post['worldnethpp_secret1'];
		} else {
			$this->data['worldnethpp_secret1'] = $this->config->get('worldnethpp_secret1');
		}

		if (isset($this->request->post['worldnethpp_currency2'])) {
			$this->data['worldnethpp_currency2'] = $this->request->post['worldnethpp_currency2'];
		} else {
			$this->data['worldnethpp_currency2'] = $this->config->get('worldnethpp_currency2');
		}
		
		if (isset($this->request->post['worldnethpp_terminal2'])) {
			$this->data['worldnethpp_terminal2'] = $this->request->post['worldnethpp_terminal2'];
		} else {
			$this->data['worldnethpp_terminal2'] = $this->config->get('worldnethpp_terminal2');
		}
		
		if (isset($this->request->post['worldnethpp_secret2'])) {
			$this->data['worldnethpp_secret2'] = $this->request->post['worldnethpp_secret2'];
		} else {
			$this->data['worldnethpp_secret2'] = $this->config->get('worldnethpp_secret2');
		}

		if (isset($this->request->post['worldnethpp_currency3'])) {
			$this->data['worldnethpp_currency3'] = $this->request->post['worldnethpp_currency3'];
		} else {
			$this->data['worldnethpp_currency3'] = $this->config->get('worldnethpp_currency3');
		}
		
		if (isset($this->request->post['worldnethpp_terminal3'])) {
			$this->data['worldnethpp_terminal3'] = $this->request->post['worldnethpp_terminal3'];
		} else {
			$this->data['worldnethpp_terminal3'] = $this->config->get('worldnethpp_terminal3');
		}
		
		if (isset($this->request->post['worldnethpp_secret3'])) {
			$this->data['worldnethpp_secret3'] = $this->request->post['worldnethpp_secret3'];
		} else {
			$this->data['worldnethpp_secret3'] = $this->config->get('worldnethpp_secret3');
		}

		if (isset($this->request->post['worldnethpp_test'])) {
			$this->data['worldnethpp_test'] = $this->request->post['worldnethpp_test'];
		} else {
			$this->data['worldnethpp_test'] = $this->config->get('worldnethpp_test');
		}
		
		if (isset($this->request->post['worldnethpp_order_status_id'])) {
			$this->data['worldnethpp_order_status_id'] = $this->request->post['worldnethpp_order_status_id'];
		} else {
			$this->data['worldnethpp_order_status_id'] = $this->config->get('worldnethpp_order_status_id'); 
		} 
		
		$this->load->model('localisation/order_status');
		
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if (isset($this->request->post['worldnethpp_status'])) {
			$this->data['worldnethpp_status'] = $this->request->post['worldnethpp_status'];
		} else {
			$this->data['worldnethpp_status'] = $this->config->get('worldnethpp_status');
		}
		
		if (isset($this->request->post['worldnethpp_send_receipt'])) {
			$this->data['worldnethpp_send_receipt'] = $this->request->post['worldnethpp_send_receipt'];
		} else {
			$this->data['worldnethpp_send_receipt'] = $this->config->get('worldnethpp_send_receipt');
		}
		
		if (isset($this->request->post['worldnethpp_sort_order'])) {
			$this->data['worldnethpp_sort_order'] = $this->request->post['worldnethpp_sort_order'];
		} else {
			$this->data['worldnethpp_sort_order'] = $this->config->get('worldnethpp_sort_order');
		}
		
		$this->template = 'payment/worldnethpp.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/worldnethpp')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['worldnethpp_gateway']) {
			$this->error['gateway'] = $this->language->get('error_gateway');
		}
		
		if (!$this->request->post['worldnethpp_terminal1']) {
			$this->error['terminal1'] = $this->language->get('error_terminal1');
		}
		
		if (!$this->request->post['worldnethpp_secret1']) {
			$this->error['secret1'] = $this->language->get('error_secret1');
		}
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>
