<?php
class ControllerPaymentWorldNetHPP extends Controller {
	protected function index() {
    		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');

		$this->language->load('payment/worldnethpp');

		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$this->load->library('encryption');
		
		$this->data['test'] = $this->config->get('worldnethpp_test');
		$this->data['text_testmode'] = $this->language->get('text_testmode');
		if(isset($this->request->get['hashValidationFailed'])) $this->data['text_failure'] = sprintf($this->language->get('text_failure'),$this->request->get['hashValidationFailed']);
		if(isset($this->request->get['previousResult'])) $this->data['text_decline'] = sprintf($this->language->get('text_decline'),$this->request->get['previousResult']);

		$this->data['action'] = 'https://'.($this->data['test'] == '1' ? 'test' : '').$this->config->get('worldnethpp_gateway').'.worldnettps.com/merchant/paymentpage';
		
		switch($order_info['currency']) {
			case $this->config->get('worldnethpp_currency3') :
				$this->data['terminalid'] = $this->config->get('worldnethpp_terminal3');
				$secret = $this->config->get('worldnethpp_secret3');
				break;
			case $this->config->get('worldnethpp_currency2') :
				$this->data['terminalid'] = $this->config->get('worldnethpp_terminal2');
				$secret = $this->config->get('worldnethpp_secret2');
				break;
			case $this->config->get('worldnethpp_currency1') :
				$this->data['terminalid'] = $this->config->get('worldnethpp_terminal1');
				$secret = $this->config->get('worldnethpp_secret1');
		}
		
		$this->data['currency'] = $order_info['currency'];

		$this->data['order_id'] = $order_info['order_id'];
		$this->data['amount'] = $this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE);
		$this->data['date_time'] = date('d-m-Y:H:i:s:000');
		$this->data['description'] = $this->config->get('config_name') . ' - #' . $order_info['order_id'];
		$this->data['name'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		
		if (!$order_info['payment_address_2']) {
			$this->data['address1'] = $order_info['payment_address_1'];
			$this->data['address2'] = $order_info['payment_city'] . ', ' . $order_info['payment_zone'];
		} else {
			$this->data['address1'] = $order_info['payment_address_1'] . ', ' . $order_info['payment_address_2'];
			$this->data['address2'] = $order_info['payment_city'] . ', ' . $order_info['payment_zone'];
		}
		
		$this->data['postcode'] = $order_info['payment_postcode'];
		$this->data['country'] = $order_info['payment_iso_code_2'];
		$this->data['telephone'] = $order_info['telephone'];
		$this->data['email'] = ($this->config->get('worldnethpp_send_receipt') == '1' ? $order_info['email'] : '');

		$this->data['receipt_page_URL'] = ((!isset($this->request->server['HTTPS']) || ($this->request->server['HTTPS'] != 'on')) ? HTTP_SERVER : HTTPS_SERVER) . 'index.php?route=payment/worldnethpp/callback';
		$this->data['validation_URL'] = ((!isset($this->request->server['HTTPS']) || ($this->request->server['HTTPS'] != 'on')) ? HTTP_SERVER : HTTPS_SERVER) . 'index.php?route=payment/worldnethpp/validate';

		$this->data['hash'] = md5($this->data['terminalid'] . $this->data['order_id'] . $this->data['amount'] . $this->data['date_time'] . $this->data['receipt_page_URL'] . $this->data['validation_URL'] . $secret);
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/payment';
		} else {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/guest_step_2';
		}
		
		$this->id = 'payment';

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/worldnethpp.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/worldnethpp.tpl';
		} else {
			$this->template = 'default/template/payment/worldnethpp.tpl';
		}	
		
		$this->render();
	}
	
	public function callback() {
		if (isset($this->request->get['RESPONSECODE']) && isset($this->request->get['TERMINALID']) && isset($this->request->get['HASH'])) {
			$this->language->load('payment/worldnethpp');
			
			switch($this->request->get['TERMINALID']) {
				case $this->config->get('worldnethpp_terminal3') :
					$this->data['currency'] =$this->config->get('worldnethpp_currency3');
					$secret = $this->config->get('worldnethpp_secret3');
					break;
				case $this->config->get('worldnethpp_terminal2') :
					$this->data['currency'] =$this->config->get('worldnethpp_currency2');
					$secret = $this->config->get('worldnethpp_secret2');
					break;
				case $this->config->get('worldnethpp_terminal1') :
					$this->data['currency'] =$this->config->get('worldnethpp_currency1');
					$secret = $this->config->get('worldnethpp_secret1');
			}
			$this->data['terminalid'] = $this->request->get['TERMINALID'];
			
			if ($this->request->get['HASH'] == md5($this->request->get['TERMINALID'] . $this->request->get['ORDERID'] . $this->request->get['AMOUNT'] . $this->request->get['DATETIME'] . $this->request->get['RESPONSECODE'] . $this->request->get['RESPONSETEXT'] . $secret)) {
				if ($this->request->get['RESPONSECODE'] == 'A') {
					// Transaction Approved
		/*			$this->load->model('checkout/order');
					
					$this->model_checkout_order->confirm($this->request->get['ORDERID'], $this->config->get('worldnethpp_order_status_id'));
					
					$message = '';
					if (isset($this->request->get['UNIQUEREF'])) $message .= 'Unique Reference: ' . $this->request->get['UNIQUEREF'] . "\n";
					if (isset($this->request->get['RESPONSETEXT'])) $message .= 'Response Message: ' . $this->request->get['RESPONSETEXT'] . "\n";
					if (isset($this->request->get['APPROVALCODE'])) $message .= 'Bank Approval Code: ' . $this->request->get['APPROVALCODE'] . "\n";
					if (isset($this->request->get['AVSRESPONSE'])) $message .= 'AVS Response: ' . $this->request->get['AVSRESPONSE'] . "\n";
					if (isset($this->request->get['CVVRESPONSE'])) $message .= 'CVV Response: ' . $this->request->get['CVVRESPONSE'] . "\n";
					if (isset($this->request->get['DATETIME'])) $message .= 'Server date & Time: ' . $this->request->get['DATETIME'] . "\n";
					
					$this->model_checkout_order->update($this->request->get['ORDERID'], $this->config->get('worldnethpp_order_status_id'), $message, FALSE);
					
					$this->data['text_result'] = $this->language->get('text_success');
					$this->data['text_result_wait'] = sprintf($this->language->get('text_success_wait'), HTTPS_SERVER . 'index.php?route=checkout/success');
				
		  	*/		$this->redirect(HTTPS_SERVER . 'index.php?route=checkout/success');				
				} else {
					// Transaction Declined
		  			$this->redirect(HTTPS_SERVER . 'index.php?route=checkout/confirm&previousResult='.$this->request->get['RESPONSETEXT']);
				}
			} else {
				// Response Hash validation failed
	    			$this->redirect(HTTPS_SERVER . 'index.php?route=checkout/confirm&hashValidationFailed='.$this->request->get['ORDERID']);
			}			
		}
	}


	public function validate() {
		if (isset($this->request->post['RESPONSECODE']) && isset($this->request->post['TERMINALID']) && isset($this->request->post['HASH'])) {
			$this->language->load('payment/worldnethpp');
			
			switch($this->request->post['TERMINALID']) {
				case $this->config->get('worldnethpp_terminal3') :
					$this->data['currency'] =$this->config->get('worldnethpp_currency3');
					$secret = $this->config->get('worldnethpp_secret3');
					break;
				case $this->config->get('worldnethpp_terminal2') :
					$this->data['currency'] =$this->config->get('worldnethpp_currency2');
					$secret = $this->config->get('worldnethpp_secret2');
					break;
				case $this->config->get('worldnethpp_terminal1') :
					$this->data['currency'] =$this->config->get('worldnethpp_currency1');
					$secret = $this->config->get('worldnethpp_secret1');
			}
			$this->data['terminalid'] = $this->request->post['TERMINALID'];
			
			if ($this->request->post['HASH'] == md5($this->request->post['TERMINALID'] . $this->request->post['ORDERID'] . $this->request->post['AMOUNT'] . $this->request->post['DATETIME'] . $this->request->post['RESPONSECODE'] . $this->request->post['RESPONSETEXT'] . $secret)) {
				if ($this->request->post['RESPONSECODE'] == 'A') {
					$this->load->model('checkout/order');
					
					$this->model_checkout_order->confirm($this->request->post['ORDERID'], $this->config->get('worldnethpp_order_status_id'));
					
					$message = '';
					if (isset($this->request->post['UNIQUEREF'])) $message .= 'Unique Reference: ' . $this->request->post['UNIQUEREF'] . "\n";
					if (isset($this->request->post['RESPONSETEXT'])) $message .= 'Response Message: ' . $this->request->post['RESPONSETEXT'] . "\n";
					if (isset($this->request->post['APPROVALCODE'])) $message .= 'Bank Approval Code: ' . $this->request->post['APPROVALCODE'] . "\n";
					if (isset($this->request->post['AVSRESPONSE'])) $message .= 'AVS Response: ' . $this->request->post['AVSRESPONSE'] . "\n";
					if (isset($this->request->post['CVVRESPONSE'])) $message .= 'CVV Response: ' . $this->request->post['CVVRESPONSE'] . "\n";
					if (isset($this->request->post['DATETIME'])) $message .= 'Server date & Time: ' . $this->request->post['DATETIME'] . "\n";
					
					$this->model_checkout_order->update($this->request->post['ORDERID'], $this->config->get('worldnethpp_order_status_id'), $message, FALSE);
					
		  			die("OK");
				} else {
					die("OK");
				}
			} else die("Response hash validation failed.");
		} else die("Not all of RESPONSECODE, TERMINALID and HASH exist in validation request.");
	}
}
?>
